######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056



#ð
library(rms)
library(rmda)

inputFile="rfGeneExp.txt"       #ļ
setwd("C:\\Users\\86151\\Desktop\\data\\gse6364\\14.Nomo")      #ùĿ¼

#ȡļ
data=read.table(inputFile, header=T, sep="\t", check.names=F, row.names=1)
data=t(data)
group=gsub("(.*)\\_(.*)", "\\2", row.names(data))
rt=cbind(as.data.frame(data), Type=group)
paste(colnames(data), collapse="+")

#ݴ
ddist=datadist(rt)
options(datadist="ddist")

#ģͣͼ
lrmModel=lrm(Type~ FTO+HNRNPC+HNRNPA2B1, data=rt, x=T, y=T)
nomo=nomogram(lrmModel, fun=plogis,
	fun.at=c(0.0001,0.1,0.3,0.5,0.7,0.9,0.99),
	lp=F, funlabel="Risk of Disease")
#ͼ
pdf("Nom.pdf", width=8, height=6)
plot(nomo)
dev.off()

#У׼
cali=calibrate(lrmModel, method="boot", B=1000)
pdf("Calibration.pdf", width=6, height=6)
plot(cali,
	xlab="Predicted probability",
	ylab="Actual probability", sub=F)
dev.off()

#ƾ
rt$Type=ifelse(rt$Type=="con", 0, 1)
dc=decision_curve(Type ~ FTO+HNRNPC, data=rt, 
	family = binomial(link ='logit'),
	thresholds= seq(0,1,by = 0.01),
	confidence.intervals = 0.95)
#DCAͼ
pdf(file="DCA.pdf", width=6, height=6)
plot_decision_curve(dc,
	curve.names="m6A genes",
	xlab="Threshold probability",
	cost.benefit.axis=T,
	col="red",
	confidence.intervals=FALSE,
	standardize=FALSE)
dev.off()

#ٴӰ
pdf(file="clinical_impact.pdf", width=6, height=6)
plot_clinical_impact(dc,
	confidence.intervals=T,
	col = c("red", "blue"))
dev.off()


######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

