######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")
#BiocManager::install("GSEABase")
#BiocManager::install("GSVA")

#install.packages("ggpubr")


#ð
library(reshape2)
library(ggpubr)
library(limma)
library(GSEABase)
library(GSVA)

expFile="6364normalize.txt"         #ļ
gmtFile="immune.gmt"            #ݼļ
clusterFile="m6Acluster.txt"    #m6Aͽļ
setwd("C:\\Users\\86151\\Desktop\\data\\gse6364\\18.ssGSEA")     #ùĿ¼

#ȡļ,ļ
rt=read.table(expFile, header=T, sep="\t", check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
data=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
data=avereps(data)

#ȡļ
geneSets=getGmt(gmtFile, geneIdType=SymbolIdentifier())

#ssGSEA
ssgseaScore=gsva(data, geneSets, method='ssgsea', kcdf='Gaussian', abs.ranking=TRUE)
#ssGSEAֽн
normalize=function(x){
  return((x-min(x))/(max(x)-min(x)))}
ssgseaScore=normalize(ssgseaScore)
#ssGSEAֽ
ssgseaOut=rbind(id=colnames(ssgseaScore), ssgseaScore)
write.table(ssgseaOut,file="ssGSEA.result.txt",sep="\t",quote=F,col.names=F)

#ȡm6A͵Ľļ
cluster=read.table(clusterFile, header=T, sep="\t", check.names=F, row.names=1)

#ݺϲ
ssgseaScore=t(ssgseaScore)
sameSample=intersect(row.names(ssgseaScore), row.names(cluster))
ssgseaScore=ssgseaScore[sameSample,,drop=F]
cluster=cluster[sameSample,"m6Acluster",drop=F]
scoreCluster=cbind(ssgseaScore, cluster)

#תggplot2ļ
data=melt(scoreCluster, id.vars=c("m6Acluster"))
colnames(data)=c("m6Acluster", "Immune", "Fraction")

#ͼ
bioCol=c("#0066FF","#FF0000","#FF9900","#6E568C","#7CC767","#223D6C","#D20A13","#FFD121","#088247","#11AA4D")
bioCol=bioCol[1:length(levels(factor(data[,"m6Acluster"])))]
p=ggboxplot(data, x="Immune", y="Fraction", color="m6Acluster",
     xlab="", 
     ylab="Immune infiltration",
     legend.title="m6Acluster",
     palette=bioCol)
p=p+rotate_x_text(50)
#ͼļ
pdf(file="boxplot.pdf", width=8, height=6)
p+stat_compare_means(aes(group=m6Acluster),symnum.args=list(cutpoints = c(0, 0.001, 0.01, 0.05, 1), symbols = c("***", "**", "*", "")),label = "p.signif")
dev.off()


######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

