######Video source: https://ke.biowolf.cn
######生信自学网: https://www.biowolf.cn/
######微信公众号：biowolf_cn
######合作邮箱：biowolf@foxmail.com
######答疑微信: 18520221056

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")

#install.packages("pheatmap")
#install.packages("reshape2")
#install.packages("ggpubr")


#引用包
library(limma)
library(pheatmap)
library(reshape2)
library(ggpubr)

gene="HNRNPA2B1"                          #基因名称
clusterFile="m6Acluster.txt"         #m6A分型的结果文件
ssgseaFile="ssGSEA.result.txt"       #ssGSEA的打分文件
setwd("C:\\Users\\86151\\Desktop\\data\\gse6364\\20.geneImmune")      #设置工作目录

#读取分型的结果文件
cluster=read.table(clusterFile, header=T, sep="\t", check.names=F, row.names=1)

#读取ssGSEA的打分文件
ssgsea=read.table(ssgseaFile, header=T, sep="\t", check.names=F, row.names=1)
ssgsea=t(ssgsea)

#数据合并
sameSample=intersect(row.names(cluster), row.names(ssgsea))
cluster=cluster[sameSample,gene,drop=F]
ssgsea=ssgsea[sameSample,,drop=F]
rt=cbind(ssgsea, cluster)
rt[,gene]=ifelse(rt[,gene]>median(rt[,gene]), "High", "Low")
rt[,gene]=factor(rt[,gene], levels=c("Low", "High"))

#把数据转换成ggplot2输入文件
data=melt(rt, id.vars=c(gene))
colnames(data)=c("Gene", "Immune", "Fraction")

#绘制箱线图
bioCol=c("#0066FF","#FF0000","#FF9900","#6E568C","#7CC767","#223D6C","#D20A13","#FFD121","#088247","#11AA4D")
bioCol=bioCol[1:length(levels(factor(data[,"Gene"])))]
p=ggboxplot(data, x="Immune", y="Fraction", color="Gene",
     xlab="",
     ylab="Immune infiltration",
     legend.title=gene,
     palette=bioCol)
p=p+rotate_x_text(50)
#输出图片文件
pdf(file="boxplot.pdf", width=8, height=6.5)
p+stat_compare_means(aes(group=Gene),symnum.args=list(cutpoints = c(0, 0.001, 0.01, 0.05, 1), symbols = c("***", "**", "*", "")),label = "p.signif")
dev.off()


######Video source: https://ke.biowolf.cn
######生信自学网: https://www.biowolf.cn/
######微信公众号：biowolf_cn
######合作邮箱：biowolf@foxmail.com
######答疑微信: 18520221056

